module Extant
  class Attribute
    attr_reader :name, :coercer_class, :pre_coerce_value, :value

    def initialize(name, value, definition)
      self.name = name
      self.has_been_coereced = false
      self.definition = definition

      if UnsetValue == value
        @value = nil
        self.is_unset = true
      else
        set_value(value)
      end
    end

    def value=(val)
      set_value(val)
      self.value_has_changed = true
    end

    def coerced?
      !!has_been_coereced
    end

    def has_changed?
      !!value_has_changed
    end

    def unset?
      !set?
    end

    def set?
      !is_unset
    end

    def coercer_name
      coercer_class.try(:coercer_name)
    end

    def inspect
      "<Extant::Attribute:#{self.object_id} Name: :#{name} Value: #{value.inspect}>"
    end

    private

    def coercer_class
      definition.coercer_class
    end

    def set_value(val)
      self.pre_coerce_value = val

      @value = if coercer_class
        coercer = coercer_class.new(val)
        coercer.coerce.tap { self.has_been_coereced = coercer.coerced? }
      else
        self.has_been_coereced = true
        val
      end

      if UncoercedValue == @value
        @value = nil

        if definition.allow_nil && pre_coerce_value == nil
          self.has_been_coereced = true
        end
      end

      self.is_unset = false
    end

    attr_accessor :value_has_changed, :has_been_coereced, :is_unset, :definition
    attr_writer :name, :coercer_class, :pre_coerce_value
  end
end
