module Extant
  class AttributeDefinition
    attr_accessor :name, :type, :coercer_class, :has_default, :default_value,
                  :allow_nil

    def initialize(model, name, opts={})
      self.name = name
      self.type = opts[:type]
      self.has_default = opts.key?(:default)
      self.default_value = opts[:default]
      self.allow_nil = opts.fetch(:allow_nil, true)

      if type
        self.coercer_class = Extant::Coercers.find(type)
      end

      model.instance_eval do
        define_method name do
          extant_attributes[name].value
        end

        define_method "#{name}=" do |val|
          extant_attributes[name].value = val
        end
      end
    end
  end
end
