module Extant::Coercers
  class Base
    UncoercedValue = Extant::UncoercedValue

    def self.coercer_name
      self.name.split("::").last.gsub(/([a-z\d])([A-Z])/,'\1_\2').downcase
    end

    def initialize(value, options={})
      self.value = value
      self.coerced = false
      self.options = {}
    end

    def coerce
      rase NotImplementedError.new("#{self.class.name} must implement #{coerce}")
    end

    def coerced?
      coerced
    end

    private

    attr_accessor :value, :coerced, :options
  end
end
